<template>
  <div>
    <l-map style="min-height:100px" ref="map" 
      @ready="onMapReady" 
      :zoom="zoom"
      :maxZoom="22"
      :minZoom="4"
      :center="mapcenter"
      @update:bounds="boundsUpdated"
      @update:center="$emit('centerMoved',$event)"
      :useGlobalLeaflet="true">
      <l-tile-layer
        :url="tileproviderurl"
        layer-type="base"
        name="OpenStreetMap"
      ></l-tile-layer>
      <!-- <div v-for="marker in markers" :key="marker">
        <l-marker v-if="marker && marker.pos[0] && marker.pos[1]" :lat-lng="[marker.pos[0], marker.pos[1]]" @click="handleMarkerClicked" >
           <l-popup>
             <div v-html="marker.popup"></div>
           </l-popup>
        </l-marker>
      </div> -->
      <l-geo-json :geojson="area"></l-geo-json>
    </l-map>
  </div>

</template>

<script>
// DON'T load Leaflet components here! // TODO: read up on this and check if leaflet itself should also be imported from beforeMount()
// Its CSS is needed though, if not imported elsewhere in your application.
import "leaflet/dist/leaflet.css"
import { LMap, LTileLayer, LGeoJson, LMarker, LPopup } from "@vue-leaflet/vue-leaflet";
import config from "../../config.json";
import {computed,nextTick,onBeforeMount,onMounted,ref, watch} from "@vue/runtime-core";
//import leaflet from "leaflet"; // TODO: optimize loading behaviour
import * as L from "leaflet";
import "leaflet.markercluster/dist/leaflet.markercluster.js";
import "leaflet/dist/leaflet.css";
import "leaflet.markercluster/dist/MarkerCluster.css";
import "leaflet.markercluster/dist/MarkerCluster.Default.css";



import turfcenter from '@turf/center';
import turfflip from '@turf/flip';

export default {
  components: {
    LMap,
    LTileLayer,
    LGeoJson,
    LMarker,
    LPopup,
  },
  props:["center","area","zoom","marker","markers"],
  setup(props,{emit}) {
    const map = ref(null);
    // config.json should include the key to a mapprovider. we use (for example) maptiler.
    const tileproviderKey = config.maptilerKey; 
    const tileproviderurl = `https://api.maptiler.com/maps/openstreetmap/256/{z}/{x}/{y}.jpg?key=${tileproviderKey}`;

    const getCenterOfPolygon = (polygon) => {
      console.log("polygon",polygon)
      polygon = turfflip(polygon);
      let center = turfcenter(polygon) //new leaflet.Polygon(polygon).getBounds().getCenter();
      console.log("center",center);
      return center.geometry.coordinates
    }

    const mapcenterdefault = [52.51899816279893,13.389167537097821];
    const mapcenter = ref(mapcenterdefault);

    const bounds = ref(null);

    watch(computed(()=>props.marker),()=>{centerMap()});

    watch(computed(()=>props.markers),()=>{
      //console.log("markers changed",props.markers);
      nextTick(()=>{createMarkers(_markerCluster)})
    });
    
    const centerMap = ()=>{
      if (!props.center && props.area){
        mapcenter.value = getCenterOfPolygon(props.area);
      }
      else if(props.marker){
        let array = [props.marker[0],props.marker[1]]
        //console.log("Map","centering on prop.marker",array);
        mapcenter.value = array;
      }
      else if (props.center){
        //console.log("Map","center based on prop.center",props.center);
        mapcenter.value = computed(()=>props.center);
      }
      else{
        //console.warn("centering of map not possible for neither props.center,props.area,props.marker present");
        mapcenter.value = mapcenterdefault
        
      }
      emit("centerMoved",{lat:mapcenter.value[0],lng:mapcenter.value[1]})
    }

    onBeforeMount(()=> {
    })

    onMounted(()=>{
     nextTick(()=>{
       centerMap();
     })
    })

    function initMarkerCluster(){
      const markerCluster=L.markerClusterGroup({
          removeOutsideVisibleBounds: true,
          chunkedLoading: true,
        })
      .addTo(map.value.leafletObject);
      return markerCluster;
    }

    function clearMarkers(markerCluster){
       markerCluster.clearLayers();
    }

    function createMarkers(markerCluster) {

        clearMarkers(markerCluster)
        
        let markers=[];
        for (let i=0;i<props.markers.length;i++){
            let m = props.markers[i]
            const marker=L.marker(
              L.latLng(m.pos[0], m.pos[1])
            );
            marker.bindPopup(m.popup);
            markers.push(marker);
        }

        markerCluster.addLayers(markers);
    }

    let _markerCluster;
    const onMapReady = ()=>{
      
      _markerCluster = initMarkerCluster();
      createMarkers(_markerCluster);

      boundsUpdated(map.value.leafletObject.getBounds())
      emit("mapReady")
    }

    const handleMarkerMoved = (e)=>{
      //console.log("marker moved",e);
      emit("markerMoved",e)
    }

    const handleMarkerClicked = (e)=>{
      //console.log("marker clicked",e);
      emit("markerClicked",e);
      mapcenter.value = e.latlng;
    }

    const boundsUpdated = (e)=>{
      console.log("bounds updated",e);
      emit("boundsChanged",e)
      bounds.value = e;
    }

    return {
      tileproviderurl,
      mapcenter,
      handleMarkerMoved,
      handleMarkerClicked,
      boundsUpdated,
      bounds,
      map,onMapReady,
    };
  },
};
</script>